/* Include files */
#include "SLUGS_Library_sfun.h"
#include "c5_SLUGS_Library.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance->instanceNumber)
#include "SLUGS_Library_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c5_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */

/* Function Declarations */
static void initialize_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance);
static void initialize_params_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance);
static void enable_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance);
static void disable_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance);
static void finalize_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance);
static void sf_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct *chartInstance);
static const mxArray *c5_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_b_sf_marshall(void *chartInstanceVoid, void *c5_u);
static const mxArray *c5_c_sf_marshall(void *chartInstanceVoid, void *c5_u);
static real32_T *c5_x(SFc5_SLUGS_LibraryInstanceStruct *chartInstance);
static real32_T *c5_y(SFc5_SLUGS_LibraryInstanceStruct *chartInstance);
static real32_T *c5_xDoty(SFc5_SLUGS_LibraryInstanceStruct *chartInstance);
static void init_dsm_address_info(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance);

/* Function Definitions */
static void initialize_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c5_is_active_c5_SLUGS_Library = 0U;
}

static void initialize_params_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance)
{
}

static void enable_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance)
{
}

static void disable_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance)
{
}

static void finalize_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance)
{
}

static void sf_c5_SLUGS_Library(SFc5_SLUGS_LibraryInstanceStruct *chartInstance)
{
  int16_T c5_i0;
  int16_T c5_i1;
  uint8_T c5_previousEvent;
  int16_T c5_i2;
  real32_T c5_b_x[3];
  int16_T c5_i3;
  real32_T c5_b_y[3];
  real32_T c5_b_xDoty;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  for(c5_i0 = 0; c5_i0 < 3; c5_i0 = (int16_T)(c5_i0 + 1)) {
    _SFD_DATA_RANGE_CHECK((real_T)c5_x(chartInstance)[c5_i0], 0UL);
  }
  for(c5_i1 = 0; c5_i1 < 3; c5_i1 = (int16_T)(c5_i1 + 1)) {
    _SFD_DATA_RANGE_CHECK((real_T)c5_y(chartInstance)[c5_i1], 1UL);
  }
  _SFD_DATA_RANGE_CHECK((real_T)*c5_xDoty(chartInstance), 2UL);
  c5_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,1);
  for(c5_i2 = 0; c5_i2 < 3; c5_i2 = (int16_T)(c5_i2 + 1)) {
    c5_b_x[c5_i2] = c5_x(chartInstance)[c5_i2];
  }
  for(c5_i3 = 0; c5_i3 < 3; c5_i3 = (int16_T)(c5_i3 + 1)) {
    c5_b_y[c5_i3] = c5_y(chartInstance)[c5_i3];
  }
  sf_debug_symbol_scope_push(3UL, 0UL);
  sf_debug_symbol_scope_add("xDoty", &c5_b_xDoty, c5_c_sf_marshall);
  sf_debug_symbol_scope_add("y", &c5_b_y, c5_b_sf_marshall);
  sf_debug_symbol_scope_add("x", &c5_b_x, c5_sf_marshall);
  CV_EML_FCN(0, 0);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,5);
  c5_b_xDoty = (c5_b_x[0] * c5_b_y[0] + c5_b_x[1] * c5_b_y[1]) + c5_b_x[2] *
    c5_b_y[2];
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-5);
  sf_debug_symbol_scope_pop();
  *c5_xDoty(chartInstance) = c5_b_xDoty;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,1);
  _sfEvent_ = c5_previousEvent;
  sf_debug_check_for_state_inconsistency(_SLUGS_LibraryMachineNumber_,
   chartInstance->chartNumber, chartInstance->instanceNumber);
}

static const mxArray *c5_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_b_y = NULL;
  int16_T c5_i4;
  real32_T c5_b_u[3];
  const mxArray *c5_c_y = NULL;
  SFc5_SLUGS_LibraryInstanceStruct *chartInstance;
  chartInstance = (SFc5_SLUGS_LibraryInstanceStruct *)chartInstanceVoid;
  c5_b_y = NULL;
  for(c5_i4 = 0; c5_i4 < 3; c5_i4 = (int16_T)(c5_i4 + 1)) {
    c5_b_u[c5_i4] = (*(real32_T (*)[3])c5_u)[c5_i4];
  }
  c5_c_y = NULL;
  sf_mex_assign(&c5_c_y, sf_mex_create(&c5_b_u, "y", 1, 0U, 1U, 1, 3));
  sf_mex_assign(&c5_b_y, c5_c_y);
  return c5_b_y;
}

static const mxArray *c5_b_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_b_y = NULL;
  int16_T c5_i5;
  real32_T c5_b_u[3];
  const mxArray *c5_c_y = NULL;
  SFc5_SLUGS_LibraryInstanceStruct *chartInstance;
  chartInstance = (SFc5_SLUGS_LibraryInstanceStruct *)chartInstanceVoid;
  c5_b_y = NULL;
  for(c5_i5 = 0; c5_i5 < 3; c5_i5 = (int16_T)(c5_i5 + 1)) {
    c5_b_u[c5_i5] = (*(real32_T (*)[3])c5_u)[c5_i5];
  }
  c5_c_y = NULL;
  sf_mex_assign(&c5_c_y, sf_mex_create(&c5_b_u, "y", 1, 0U, 1U, 1, 3));
  sf_mex_assign(&c5_b_y, c5_c_y);
  return c5_b_y;
}

static const mxArray *c5_c_sf_marshall(void *chartInstanceVoid, void *c5_u)
{
  const mxArray *c5_b_y = NULL;
  real32_T c5_b_u;
  const mxArray *c5_c_y = NULL;
  SFc5_SLUGS_LibraryInstanceStruct *chartInstance;
  chartInstance = (SFc5_SLUGS_LibraryInstanceStruct *)chartInstanceVoid;
  c5_b_y = NULL;
  c5_b_u = *(real32_T *)c5_u;
  c5_c_y = NULL;
  sf_mex_assign(&c5_c_y, sf_mex_create(&c5_b_u, "y", 1, 0U, 0U, 0));
  sf_mex_assign(&c5_b_y, c5_c_y);
  return c5_b_y;
}

const mxArray *sf_c5_SLUGS_Library_get_eml_resolved_functions_info(void)
{
  const mxArray *c5_nameCaptureInfo = NULL;
  c5_nameCaptureInfo = NULL;
  sf_mex_assign(&c5_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c5_nameCaptureInfo;
}

static real32_T *c5_x(SFc5_SLUGS_LibraryInstanceStruct *chartInstance)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance->S, 0);
}

static real32_T *c5_y(SFc5_SLUGS_LibraryInstanceStruct *chartInstance)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance->S, 1);
}

static real32_T *c5_xDoty(SFc5_SLUGS_LibraryInstanceStruct *chartInstance)
{
  return (real32_T *)ssGetOutputPortSignal(chartInstance->S, 1);
}

static void init_dsm_address_info(SFc5_SLUGS_LibraryInstanceStruct
 *chartInstance)
{
}

/* SFunction Glue Code */
void sf_c5_SLUGS_Library_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2873505499U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3139956117U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(4114292538U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2465289333U);
}

mxArray *sf_c5_SLUGS_Library_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(791703676U);
    pr[1] = (double)(1911612341U);
    pr[2] = (double)(1019709880U);
    pr[3] = (double)(3239626058U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
 fullDebuggerInitialization)
{
  SFc5_SLUGS_LibraryInstanceStruct *chartInstance;
  chartInstance = (SFc5_SLUGS_LibraryInstanceStruct *) ((ChartInfoStruct
    *)(ssGetUserData(S)))->chartInstance;
  if(ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent =
          sf_debug_initialize_chart(_SLUGS_LibraryMachineNumber_,
         5,
         1,
         1,
         3,
         0,
         0,
         0,
         0,
         &(chartInstance->chartNumber),
         &(chartInstance->instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_SLUGS_LibraryMachineNumber_,chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(_SLUGS_LibraryMachineNumber_,
           chartInstance->chartNumber,
           0,
           0,
           0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_SINGLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"x",0,c5_sf_marshall);
          }
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(1,1,1,0,SF_SINGLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"y",0,c5_b_sf_marshall);
          }
          _SFD_SET_DATA_PROPS(2,2,0,1,SF_SINGLE,0,NULL,0,0,0,0.0,1.0,0,"xDoty",0,c5_c_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,172);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
        _SFD_SET_DATA_VALUE_PTR(0UL, c5_x(chartInstance));
        _SFD_SET_DATA_VALUE_PTR(1UL, c5_y(chartInstance));
        _SFD_SET_DATA_VALUE_PTR(2UL, c5_xDoty(chartInstance));
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_SLUGS_LibraryMachineNumber_,chartInstance->chartNumber,chartInstance->instanceNumber);
  }
}

static void sf_opaque_initialize_c5_SLUGS_Library(void *chartInstanceVar)
{
  chart_debug_initialization(((SFc5_SLUGS_LibraryInstanceStruct*)
    chartInstanceVar)->S,0);
  initialize_params_c5_SLUGS_Library((SFc5_SLUGS_LibraryInstanceStruct*)
   chartInstanceVar);
  initialize_c5_SLUGS_Library((SFc5_SLUGS_LibraryInstanceStruct*)
   chartInstanceVar);
}

static void sf_opaque_enable_c5_SLUGS_Library(void *chartInstanceVar)
{
  enable_c5_SLUGS_Library((SFc5_SLUGS_LibraryInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c5_SLUGS_Library(void *chartInstanceVar)
{
  disable_c5_SLUGS_Library((SFc5_SLUGS_LibraryInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c5_SLUGS_Library(void *chartInstanceVar)
{
  sf_c5_SLUGS_Library((SFc5_SLUGS_LibraryInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_terminate_c5_SLUGS_Library(void *chartInstanceVar)
{
  if(chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc5_SLUGS_LibraryInstanceStruct*) chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S)) {
      sf_clear_rtw_identifier(S);
    }
    finalize_c5_SLUGS_Library((SFc5_SLUGS_LibraryInstanceStruct*)
     chartInstanceVar);
    free((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void mdlProcessParameters_c5_SLUGS_Library(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c5_SLUGS_Library((SFc5_SLUGS_LibraryInstanceStruct*)(((ChartInfoStruct
      *)ssGetUserData(S))->chartInstance));
}

static void mdlSetWorkWidths_c5_SLUGS_Library(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("SLUGS_Library",5);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("SLUGS_Library",5,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"SLUGS_Library",5,2);
      sf_mark_chart_reusable_outputs(S,"SLUGS_Library",5,1);
    }
    if (!sf_is_chart_instance_optimized_out("SLUGS_Library",5)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("SLUGS_Library",5);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1282741595U));
  ssSetChecksum1(S,(1245186842U));
  ssSetChecksum2(S,(291142322U));
  ssSetChecksum3(S,(3304972404U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c5_SLUGS_Library(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "SLUGS_Library", 5);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c5_SLUGS_Library(SimStruct *S)
{
  SFc5_SLUGS_LibraryInstanceStruct *chartInstance;
  chartInstance = (SFc5_SLUGS_LibraryInstanceStruct
    *)malloc(sizeof(SFc5_SLUGS_LibraryInstanceStruct));
  if(chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }
  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway = sf_opaque_gateway_c5_SLUGS_Library;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c5_SLUGS_Library;
  chartInstance->chartInfo.terminateChart = sf_opaque_terminate_c5_SLUGS_Library;
  chartInstance->chartInfo.enableChart = sf_opaque_enable_c5_SLUGS_Library;
  chartInstance->chartInfo.disableChart = sf_opaque_disable_c5_SLUGS_Library;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c5_SLUGS_Library;
  chartInstance->chartInfo.mdlStart = mdlStart_c5_SLUGS_Library;
  chartInstance->chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c5_SLUGS_Library;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info(chartInstance);
  }
  chart_debug_initialization(S,1);
}

void c5_SLUGS_Library_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c5_SLUGS_Library(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c5_SLUGS_Library(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c5_SLUGS_Library(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c5_SLUGS_Library_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

