/* Include files */
#include "controlMCUSlugsMKII_sfun.h"
#include "c13_controlMCUSlugsMKII.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "controlMCUSlugsMKII_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c13_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc13_controlMCUSlugsMKIIInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c13_controlMCUSlugsMKII(void);
static void initialize_params_c13_controlMCUSlugsMKII(void);
static void enable_c13_controlMCUSlugsMKII(void);
static void disable_c13_controlMCUSlugsMKII(void);
static void finalize_c13_controlMCUSlugsMKII(void);
static void sf_c13_controlMCUSlugsMKII(void);
static const mxArray *c13_sf_marshall(void *c13_chartInstance, void *c13_u);
static const mxArray *c13_b_sf_marshall(void *c13_chartInstance, void *c13_u);
static const mxArray *c13_c_sf_marshall(void *c13_chartInstance, void *c13_u);
static const mxArray *c13_d_sf_marshall(void *c13_chartInstance, void *c13_u);
static real32_T *c13_u1(void);
static real32_T *c13_y(void);
static real32_T *c13_u2(void);
static real32_T *c13_u3(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c13_controlMCUSlugsMKII(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c13_is_active_c13_controlMCUSlugsMKII = 0U;
}

static void initialize_params_c13_controlMCUSlugsMKII(void)
{
}

static void enable_c13_controlMCUSlugsMKII(void)
{
}

static void disable_c13_controlMCUSlugsMKII(void)
{
}

static void finalize_c13_controlMCUSlugsMKII(void)
{
}

static void sf_c13_controlMCUSlugsMKII(void)
{
  int16_T c13_i0;
  uint8_T c13_previousEvent;
  real32_T c13_b_u1;
  real32_T c13_b_u2;
  real32_T c13_b_u3;
  real32_T c13_b_y[3];
  int16_T c13_i1;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_DATA_RANGE_CHECK((real_T)*c13_u1(), 3UL);
  for(c13_i0 = 0; c13_i0 < 3; c13_i0 = (int16_T)(c13_i0 + 1)) {
    _SFD_DATA_RANGE_CHECK((real_T)c13_y()[c13_i0], 2UL);
  }
  _SFD_DATA_RANGE_CHECK((real_T)*c13_u2(), 1UL);
  _SFD_DATA_RANGE_CHECK((real_T)*c13_u3(), 0UL);
  c13_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,12);
  c13_b_u1 = *c13_u1();
  c13_b_u2 = *c13_u2();
  c13_b_u3 = *c13_u3();
  sf_debug_symbol_scope_push(4UL, 0UL);
  sf_debug_symbol_scope_add("y", &c13_b_y, c13_d_sf_marshall);
  sf_debug_symbol_scope_add("u3", &c13_b_u3, c13_c_sf_marshall);
  sf_debug_symbol_scope_add("u2", &c13_b_u2, c13_b_sf_marshall);
  sf_debug_symbol_scope_add("u1", &c13_b_u1, c13_sf_marshall);
  CV_EML_FCN(0, 0);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,5);
  c13_b_y[0] = c13_b_u1;
  c13_b_y[1] = c13_b_u2;
  c13_b_y[2] = c13_b_u3;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-5);
  sf_debug_symbol_scope_pop();
  for(c13_i1 = 0; c13_i1 < 3; c13_i1 = (int16_T)(c13_i1 + 1)) {
    c13_y()[c13_i1] = c13_b_y[c13_i1];
  }
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,12);
  _sfEvent_ = c13_previousEvent;
  sf_debug_check_for_state_inconsistency(_controlMCUSlugsMKIIMachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static const mxArray *c13_sf_marshall(void *c13_chartInstance, void *c13_u)
{
  const mxArray *c13_b_y = NULL;
  real32_T c13_b_u;
  const mxArray *c13_c_y = NULL;
  c13_b_y = NULL;
  c13_b_u = *(real32_T *)c13_u;
  c13_c_y = NULL;
  sf_mex_assign(&c13_c_y, sf_mex_create(&c13_b_u, "y", 1, 0U, 0U, 0));
  sf_mex_assign(&c13_b_y, c13_c_y);
  return c13_b_y;
}

static const mxArray *c13_b_sf_marshall(void *c13_chartInstance, void *c13_u)
{
  const mxArray *c13_b_y = NULL;
  real32_T c13_b_u;
  const mxArray *c13_c_y = NULL;
  c13_b_y = NULL;
  c13_b_u = *(real32_T *)c13_u;
  c13_c_y = NULL;
  sf_mex_assign(&c13_c_y, sf_mex_create(&c13_b_u, "y", 1, 0U, 0U, 0));
  sf_mex_assign(&c13_b_y, c13_c_y);
  return c13_b_y;
}

static const mxArray *c13_c_sf_marshall(void *c13_chartInstance, void *c13_u)
{
  const mxArray *c13_b_y = NULL;
  real32_T c13_b_u;
  const mxArray *c13_c_y = NULL;
  c13_b_y = NULL;
  c13_b_u = *(real32_T *)c13_u;
  c13_c_y = NULL;
  sf_mex_assign(&c13_c_y, sf_mex_create(&c13_b_u, "y", 1, 0U, 0U, 0));
  sf_mex_assign(&c13_b_y, c13_c_y);
  return c13_b_y;
}

static const mxArray *c13_d_sf_marshall(void *c13_chartInstance, void *c13_u)
{
  const mxArray *c13_b_y = NULL;
  int16_T c13_i2;
  real32_T c13_b_u[3];
  const mxArray *c13_c_y = NULL;
  c13_b_y = NULL;
  for(c13_i2 = 0; c13_i2 < 3; c13_i2 = (int16_T)(c13_i2 + 1)) {
    c13_b_u[c13_i2] = (*(real32_T (*)[3])c13_u)[c13_i2];
  }
  c13_c_y = NULL;
  sf_mex_assign(&c13_c_y, sf_mex_create(&c13_b_u, "y", 1, 0U, 1U, 1, 3));
  sf_mex_assign(&c13_b_y, c13_c_y);
  return c13_b_y;
}

const mxArray *sf_c13_controlMCUSlugsMKII_get_eml_resolved_functions_info(void)
{
  const mxArray *c13_nameCaptureInfo = NULL;
  c13_nameCaptureInfo = NULL;
  sf_mex_assign(&c13_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c13_nameCaptureInfo;
}

static real32_T *c13_u1(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static real32_T *c13_y(void)
{
  return (real32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static real32_T *c13_u2(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static real32_T *c13_u3(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 2);
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c13_controlMCUSlugsMKII_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(615617483U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3773128608U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1754083360U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(270987258U);
}

mxArray *sf_c13_controlMCUSlugsMKII_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(4252663725U);
    pr[1] = (double)(3792648650U);
    pr[2] = (double)(1947400732U);
    pr[3] = (double)(2106118845U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
 fullDebuggerInitialization)
{
  if(ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent =
          sf_debug_initialize_chart(_controlMCUSlugsMKIIMachineNumber_,
         13,
         1,
         1,
         4,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_controlMCUSlugsMKIIMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_controlMCUSlugsMKIIMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          _SFD_SET_DATA_PROPS(3,1,1,0,SF_SINGLE,0,NULL,0,0,0,0.0,1.0,0,"u1",0,c13_sf_marshall);
          {
            unsigned int dimVector[1];
            dimVector[0]= 3;
            _SFD_SET_DATA_PROPS(2,2,0,1,SF_SINGLE,1,&(dimVector[0]),0,0,0,0.0,1.0,0,"y",0,c13_d_sf_marshall);
          }
          _SFD_SET_DATA_PROPS(1,1,1,0,SF_SINGLE,0,NULL,0,0,0,0.0,1.0,0,"u2",0,c13_b_sf_marshall);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_SINGLE,0,NULL,0,0,0,0.0,1.0,0,"u3",0,c13_c_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,0,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,159);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
        _SFD_SET_DATA_VALUE_PTR(3UL, c13_u1());
        _SFD_SET_DATA_VALUE_PTR(2UL, c13_y());
        _SFD_SET_DATA_VALUE_PTR(1UL, c13_u2());
        _SFD_SET_DATA_VALUE_PTR(0UL, c13_u3());
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_controlMCUSlugsMKIIMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c13_controlMCUSlugsMKII(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c13_controlMCUSlugsMKII();
  initialize_c13_controlMCUSlugsMKII();
}

static void sf_opaque_enable_c13_controlMCUSlugsMKII(void *chartInstanceVar)
{
  enable_c13_controlMCUSlugsMKII();
}

static void sf_opaque_disable_c13_controlMCUSlugsMKII(void *chartInstanceVar)
{
  disable_c13_controlMCUSlugsMKII();
}

static void sf_opaque_gateway_c13_controlMCUSlugsMKII(void *chartInstanceVar)
{
  sf_c13_controlMCUSlugsMKII();
}

static void sf_opaque_terminate_c13_controlMCUSlugsMKII(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c13_controlMCUSlugsMKII();
}

static void mdlProcessParameters_c13_controlMCUSlugsMKII(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c13_controlMCUSlugsMKII();
}

static void mdlSetWorkWidths_c13_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("controlMCUSlugsMKII",13);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("controlMCUSlugsMKII",13,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"controlMCUSlugsMKII",13,3);
      sf_mark_chart_reusable_outputs(S,"controlMCUSlugsMKII",13,1);
    }
    if (!sf_is_chart_instance_optimized_out("controlMCUSlugsMKII",13)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("controlMCUSlugsMKII",13);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2513230016U));
  ssSetChecksum1(S,(993849419U));
  ssSetChecksum2(S,(4269682996U));
  ssSetChecksum3(S,(1045556106U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c13_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "controlMCUSlugsMKII", 13);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c13_controlMCUSlugsMKII(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c13_controlMCUSlugsMKII;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c13_controlMCUSlugsMKII;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c13_controlMCUSlugsMKII;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c13_controlMCUSlugsMKII;
  chartInstance.chartInfo.disableChart =
    sf_opaque_disable_c13_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c13_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlStart = mdlStart_c13_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c13_controlMCUSlugsMKII;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  chart_debug_initialization(S,1);
}

void c13_controlMCUSlugsMKII_method_dispatcher(SimStruct *S, int_T method, void
 *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c13_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c13_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c13_controlMCUSlugsMKII(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c13_controlMCUSlugsMKII_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

