/* Include files */
#include "controlMCUSlugsMKII_sfun.h"
#include "c30_controlMCUSlugsMKII.h"

/* Type Definitions */

/* Named Constants */
#define c30_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc30_controlMCUSlugsMKIIInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c30_controlMCUSlugsMKII(void);
static void initialize_params_c30_controlMCUSlugsMKII(void);
static void enable_c30_controlMCUSlugsMKII(void);
static void disable_c30_controlMCUSlugsMKII(void);
static void finalize_c30_controlMCUSlugsMKII(void);
static void sf_c30_controlMCUSlugsMKII(void);
static real32_T *c30_u1(void);
static real32_T *c30_y(void);
static real32_T *c30_u2(void);
static real32_T *c30_u3(void);
static real32_T *c30_u4(void);
static real32_T *c30_u5(void);
static real32_T *c30_u6(void);
static real32_T *c30_u7(void);
static real32_T *c30_u8(void);
static real32_T *c30_u9(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c30_controlMCUSlugsMKII(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void initialize_params_c30_controlMCUSlugsMKII(void)
{
}

static void enable_c30_controlMCUSlugsMKII(void)
{
}

static void disable_c30_controlMCUSlugsMKII(void)
{
}

static void finalize_c30_controlMCUSlugsMKII(void)
{
}

static void sf_c30_controlMCUSlugsMKII(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  c30_y()[0] = *c30_u1();
  c30_y()[1] = *c30_u2();
  c30_y()[2] = *c30_u3();
  c30_y()[3] = *c30_u4();
  c30_y()[4] = *c30_u5();
  c30_y()[5] = *c30_u6();
  c30_y()[6] = *c30_u7();
  c30_y()[7] = *c30_u8();
  c30_y()[8] = *c30_u9();
}

const mxArray *sf_c30_controlMCUSlugsMKII_get_eml_resolved_functions_info(void)
{
  const mxArray *c30_nameCaptureInfo = NULL;
  c30_nameCaptureInfo = NULL;
  sf_mex_assign(&c30_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c30_nameCaptureInfo;
}

static real32_T *c30_u1(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static real32_T *c30_y(void)
{
  return (real32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static real32_T *c30_u2(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static real32_T *c30_u3(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 2);
}

static real32_T *c30_u4(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 3);
}

static real32_T *c30_u5(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 4);
}

static real32_T *c30_u6(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 5);
}

static real32_T *c30_u7(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 6);
}

static real32_T *c30_u8(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 7);
}

static real32_T *c30_u9(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 8);
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c30_controlMCUSlugsMKII_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(473653162U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(657770182U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3083142846U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3385871257U);
}

mxArray *sf_c30_controlMCUSlugsMKII_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1020786225U);
    pr[1] = (double)(1379531197U);
    pr[2] = (double)(3726868171U);
    pr[3] = (double)(2042210258U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,9,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }
    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,7,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,7,"type",mxType);
    }
    mxSetField(mxData,7,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,8,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,8,"type",mxType);
    }
    mxSetField(mxData,8,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(9);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void sf_opaque_initialize_c30_controlMCUSlugsMKII(void *chartInstanceVar)
{
  initialize_params_c30_controlMCUSlugsMKII();
  initialize_c30_controlMCUSlugsMKII();
}

static void sf_opaque_enable_c30_controlMCUSlugsMKII(void *chartInstanceVar)
{
  enable_c30_controlMCUSlugsMKII();
}

static void sf_opaque_disable_c30_controlMCUSlugsMKII(void *chartInstanceVar)
{
  disable_c30_controlMCUSlugsMKII();
}

static void sf_opaque_gateway_c30_controlMCUSlugsMKII(void *chartInstanceVar)
{
  sf_c30_controlMCUSlugsMKII();
}

static void sf_opaque_terminate_c30_controlMCUSlugsMKII(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c30_controlMCUSlugsMKII();
}

static void mdlProcessParameters_c30_controlMCUSlugsMKII(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c30_controlMCUSlugsMKII();
}

static void mdlSetWorkWidths_c30_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("controlMCUSlugsMKII",30);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("controlMCUSlugsMKII",30,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 6, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 7, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 8, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"controlMCUSlugsMKII",30,9);
      sf_mark_chart_reusable_outputs(S,"controlMCUSlugsMKII",30,1);
    }
    if (!sf_is_chart_instance_optimized_out("controlMCUSlugsMKII",30)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("controlMCUSlugsMKII",30);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(77550134U));
  ssSetChecksum1(S,(1304826506U));
  ssSetChecksum2(S,(303779131U));
  ssSetChecksum3(S,(1607210288U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c30_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "controlMCUSlugsMKII", 30);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c30_controlMCUSlugsMKII(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c30_controlMCUSlugsMKII;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c30_controlMCUSlugsMKII;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c30_controlMCUSlugsMKII;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c30_controlMCUSlugsMKII;
  chartInstance.chartInfo.disableChart =
    sf_opaque_disable_c30_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c30_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlStart = mdlStart_c30_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c30_controlMCUSlugsMKII;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
}

void c30_controlMCUSlugsMKII_method_dispatcher(SimStruct *S, int_T method, void
 *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c30_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c30_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c30_controlMCUSlugsMKII(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c30_controlMCUSlugsMKII_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

