/* Include files */
#include "controlMCUSlugsMKII_sfun.h"
#include "c32_controlMCUSlugsMKII.h"

/* Type Definitions */

/* Named Constants */
#define c32_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc32_controlMCUSlugsMKIIInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c32_controlMCUSlugsMKII(void);
static void initialize_params_c32_controlMCUSlugsMKII(void);
static void enable_c32_controlMCUSlugsMKII(void);
static void disable_c32_controlMCUSlugsMKII(void);
static void finalize_c32_controlMCUSlugsMKII(void);
static void sf_c32_controlMCUSlugsMKII(void);
static real32_T *c32_u1(void);
static real32_T *c32_y(void);
static real32_T *c32_u2(void);
static real32_T *c32_u3(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c32_controlMCUSlugsMKII(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void initialize_params_c32_controlMCUSlugsMKII(void)
{
}

static void enable_c32_controlMCUSlugsMKII(void)
{
}

static void disable_c32_controlMCUSlugsMKII(void)
{
}

static void finalize_c32_controlMCUSlugsMKII(void)
{
}

static void sf_c32_controlMCUSlugsMKII(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  c32_y()[0] = *c32_u1();
  c32_y()[1] = *c32_u2();
  c32_y()[2] = *c32_u3();
}

const mxArray *sf_c32_controlMCUSlugsMKII_get_eml_resolved_functions_info(void)
{
  const mxArray *c32_nameCaptureInfo = NULL;
  c32_nameCaptureInfo = NULL;
  sf_mex_assign(&c32_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c32_nameCaptureInfo;
}

static real32_T *c32_u1(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static real32_T *c32_y(void)
{
  return (real32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static real32_T *c32_u2(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static real32_T *c32_u3(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 2);
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c32_controlMCUSlugsMKII_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(977671032U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2686000140U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(1986503601U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4208958073U);
}

mxArray *sf_c32_controlMCUSlugsMKII_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3758079856U);
    pr[1] = (double)(2399079661U);
    pr[2] = (double)(1881148990U);
    pr[3] = (double)(4048755490U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(3);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void sf_opaque_initialize_c32_controlMCUSlugsMKII(void *chartInstanceVar)
{
  initialize_params_c32_controlMCUSlugsMKII();
  initialize_c32_controlMCUSlugsMKII();
}

static void sf_opaque_enable_c32_controlMCUSlugsMKII(void *chartInstanceVar)
{
  enable_c32_controlMCUSlugsMKII();
}

static void sf_opaque_disable_c32_controlMCUSlugsMKII(void *chartInstanceVar)
{
  disable_c32_controlMCUSlugsMKII();
}

static void sf_opaque_gateway_c32_controlMCUSlugsMKII(void *chartInstanceVar)
{
  sf_c32_controlMCUSlugsMKII();
}

static void sf_opaque_terminate_c32_controlMCUSlugsMKII(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c32_controlMCUSlugsMKII();
}

static void mdlProcessParameters_c32_controlMCUSlugsMKII(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c32_controlMCUSlugsMKII();
}

static void mdlSetWorkWidths_c32_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("controlMCUSlugsMKII",32);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("controlMCUSlugsMKII",32,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"controlMCUSlugsMKII",32,3);
      sf_mark_chart_reusable_outputs(S,"controlMCUSlugsMKII",32,1);
    }
    if (!sf_is_chart_instance_optimized_out("controlMCUSlugsMKII",32)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("controlMCUSlugsMKII",32);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3506771270U));
  ssSetChecksum1(S,(896001382U));
  ssSetChecksum2(S,(1760341690U));
  ssSetChecksum3(S,(1126758725U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c32_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "controlMCUSlugsMKII", 32);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c32_controlMCUSlugsMKII(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c32_controlMCUSlugsMKII;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c32_controlMCUSlugsMKII;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c32_controlMCUSlugsMKII;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c32_controlMCUSlugsMKII;
  chartInstance.chartInfo.disableChart =
    sf_opaque_disable_c32_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c32_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlStart = mdlStart_c32_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c32_controlMCUSlugsMKII;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
}

void c32_controlMCUSlugsMKII_method_dispatcher(SimStruct *S, int_T method, void
 *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c32_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c32_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c32_controlMCUSlugsMKII(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c32_controlMCUSlugsMKII_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

