/* Include files */
#include "controlMCUSlugsMKII_sfun.h"
#include "c49_controlMCUSlugsMKII.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "controlMCUSlugsMKII_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c49_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc49_controlMCUSlugsMKIIInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c49_controlMCUSlugsMKII(void);
static void initialize_params_c49_controlMCUSlugsMKII(void);
static void enable_c49_controlMCUSlugsMKII(void);
static void disable_c49_controlMCUSlugsMKII(void);
static void finalize_c49_controlMCUSlugsMKII(void);
static void sf_c49_controlMCUSlugsMKII(void);
static const mxArray *c49_sf_marshall(void *c49_chartInstance, void *c49_b_u);
static const mxArray *c49_b_sf_marshall(void *c49_chartInstance, void *c49_b_u);
static const mxArray *c49_c_sf_marshall(void *c49_chartInstance, void *c49_b_u);
static const mxArray *c49_d_sf_marshall(void *c49_chartInstance, void *c49_b_u);
static const mxArray *c49_e_sf_marshall(void *c49_chartInstance, void *c49_b_u);
static real32_T *c49_u(void);
static real32_T *c49_y(void);
static real_T *c49_T(void);
static real_T *c49_f(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c49_controlMCUSlugsMKII(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c49_a_not_empty = false;
  chartInstance.c49_b_not_empty = false;
  chartInstance.c49_y_km1_not_empty = false;
  chartInstance.c49_u_km1_not_empty = false;
  chartInstance.c49_is_active_c49_controlMCUSlugsMKII = 0U;
}

static void initialize_params_c49_controlMCUSlugsMKII(void)
{
}

static void enable_c49_controlMCUSlugsMKII(void)
{
}

static void disable_c49_controlMCUSlugsMKII(void)
{
}

static void finalize_c49_controlMCUSlugsMKII(void)
{
}

static void sf_c49_controlMCUSlugsMKII(void)
{
  uint8_T c49_previousEvent;
  real32_T c49_b_u;
  real_T c49_b_T;
  real_T c49_b_f;
  real_T c49_omega;
  real32_T c49_b_y;
  real_T c49_A;
  real_T c49_B;
  real_T c49_x;
  real_T c49_c_y;
  real_T c49_b_A;
  real_T c49_b_B;
  real_T c49_b_x;
  real_T c49_d_y;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_DATA_RANGE_CHECK((real_T)*c49_u(), 1UL);
  _SFD_DATA_RANGE_CHECK((real_T)*c49_y(), 0UL);
  _SFD_DATA_RANGE_CHECK(*c49_T(), 2UL);
  _SFD_DATA_RANGE_CHECK(*c49_f(), 3UL);
  c49_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,42);
  c49_b_u = *c49_u();
  c49_b_T = *c49_T();
  c49_b_f = *c49_f();
  sf_debug_symbol_scope_push(9UL, 0UL);
  sf_debug_symbol_scope_add_verbose("u_km1", 1L, 0UL, 0UL, 0UL, 0UL, 1.0, 0L,
   0.0, 0UL, 0L, 0UL, 0L, 0, &chartInstance.c49_u_km1);
  sf_debug_symbol_scope_add_verbose("y_km1", 1L, 0UL, 0UL, 0UL, 0UL, 1.0, 0L,
   0.0, 0UL, 0L, 0UL, 0L, 0, &chartInstance.c49_y_km1);
  sf_debug_symbol_scope_add_verbose("b", 0L, 0UL, 0UL, 0UL, 0UL, 1.0, 0L, 0.0,
   0UL, 0L, 0UL, 0L, 0, &chartInstance.c49_b);
  sf_debug_symbol_scope_add_verbose("a", 0L, 0UL, 0UL, 0UL, 0UL, 1.0, 0L, 0.0,
   0UL, 0L, 0UL, 0L, 0, &chartInstance.c49_a);
  sf_debug_symbol_scope_add("omega", &c49_omega, c49_e_sf_marshall);
  sf_debug_symbol_scope_add("y", &c49_b_y, c49_d_sf_marshall);
  sf_debug_symbol_scope_add("f", &c49_b_f, c49_c_sf_marshall);
  sf_debug_symbol_scope_add("T", &c49_b_T, c49_b_sf_marshall);
  sf_debug_symbol_scope_add("u", &c49_b_u, c49_sf_marshall);
  CV_EML_FCN(0, 0);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,9);
  if(CV_EML_IF(0, 0, !chartInstance.c49_a_not_empty)) {
    /* tf = [T*omega/(2+T*omega) T*omega/(2+T*omega)],[1 (T*omega-2)/(T*omega+2)] */
    /* tf = [a a],[1 -b] */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,12);
    c49_omega = 6.2831853071795862E+000 * c49_b_f;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,13);
    c49_A = c49_b_T * c49_omega;
    c49_B = 2.0 + c49_b_T * c49_omega;
    c49_x = c49_A;
    c49_c_y = c49_B;
    chartInstance.c49_a = c49_x / c49_c_y;
    chartInstance.c49_a_not_empty = true;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,14);
    c49_b_A = -(c49_b_T * c49_omega - 2.0);
    c49_b_B = c49_b_T * c49_omega + 2.0;
    c49_b_x = c49_b_A;
    c49_d_y = c49_b_B;
    chartInstance.c49_b = c49_b_x / c49_d_y;
    chartInstance.c49_b_not_empty = true;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,15);
    chartInstance.c49_y_km1 = c49_b_u;
    chartInstance.c49_y_km1_not_empty = true;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,16);
    chartInstance.c49_u_km1 = c49_b_u;
    chartInstance.c49_u_km1_not_empty = true;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,19);
  c49_b_y = (real32_T)chartInstance.c49_a * (c49_b_u + chartInstance.c49_u_km1)
    + (real32_T)chartInstance.c49_b * chartInstance.
    c49_y_km1;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,20);
  chartInstance.c49_y_km1 = c49_b_y;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,21);
  chartInstance.c49_u_km1 = c49_b_u;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-21);
  sf_debug_symbol_scope_pop();
  *c49_y() = c49_b_y;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,42);
  _sfEvent_ = c49_previousEvent;
  sf_debug_check_for_state_inconsistency(_controlMCUSlugsMKIIMachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static const mxArray *c49_sf_marshall(void *c49_chartInstance, void *c49_b_u)
{
  const mxArray *c49_b_y = NULL;
  real32_T c49_c_u;
  const mxArray *c49_c_y = NULL;
  c49_b_y = NULL;
  c49_c_u = *(real32_T *)c49_b_u;
  c49_c_y = NULL;
  sf_mex_assign(&c49_c_y, sf_mex_create(&c49_c_u, "y", 1, 0U, 0U, 0));
  sf_mex_assign(&c49_b_y, c49_c_y);
  return c49_b_y;
}

static const mxArray *c49_b_sf_marshall(void *c49_chartInstance, void *c49_b_u)
{
  const mxArray *c49_b_y = NULL;
  real_T c49_c_u;
  const mxArray *c49_c_y = NULL;
  c49_b_y = NULL;
  c49_c_u = *(real_T *)c49_b_u;
  c49_c_y = NULL;
  sf_mex_assign(&c49_c_y, sf_mex_create(&c49_c_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c49_b_y, c49_c_y);
  return c49_b_y;
}

static const mxArray *c49_c_sf_marshall(void *c49_chartInstance, void *c49_b_u)
{
  const mxArray *c49_b_y = NULL;
  real_T c49_c_u;
  const mxArray *c49_c_y = NULL;
  c49_b_y = NULL;
  c49_c_u = *(real_T *)c49_b_u;
  c49_c_y = NULL;
  sf_mex_assign(&c49_c_y, sf_mex_create(&c49_c_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c49_b_y, c49_c_y);
  return c49_b_y;
}

static const mxArray *c49_d_sf_marshall(void *c49_chartInstance, void *c49_b_u)
{
  const mxArray *c49_b_y = NULL;
  real32_T c49_c_u;
  const mxArray *c49_c_y = NULL;
  c49_b_y = NULL;
  c49_c_u = *(real32_T *)c49_b_u;
  c49_c_y = NULL;
  sf_mex_assign(&c49_c_y, sf_mex_create(&c49_c_u, "y", 1, 0U, 0U, 0));
  sf_mex_assign(&c49_b_y, c49_c_y);
  return c49_b_y;
}

static const mxArray *c49_e_sf_marshall(void *c49_chartInstance, void *c49_b_u)
{
  const mxArray *c49_b_y = NULL;
  real_T c49_c_u;
  const mxArray *c49_c_y = NULL;
  c49_b_y = NULL;
  c49_c_u = *(real_T *)c49_b_u;
  c49_c_y = NULL;
  sf_mex_assign(&c49_c_y, sf_mex_create(&c49_c_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c49_b_y, c49_c_y);
  return c49_b_y;
}

const mxArray *sf_c49_controlMCUSlugsMKII_get_eml_resolved_functions_info(void)
{
  const mxArray *c49_nameCaptureInfo = NULL;
  c49_nameCaptureInfo = NULL;
  sf_mex_assign(&c49_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c49_nameCaptureInfo;
}

static real32_T *c49_u(void)
{
  return (real32_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static real32_T *c49_y(void)
{
  return (real32_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static real_T *c49_T(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static real_T *c49_f(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c49_controlMCUSlugsMKII_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(772824267U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2037059839U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(282353585U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4163992693U);
}

mxArray *sf_c49_controlMCUSlugsMKII_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1850470311U);
    pr[1] = (double)(1024180651U);
    pr[2] = (double)(2580554239U);
    pr[3] = (double)(536100190U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(1));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(9));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
 fullDebuggerInitialization)
{
  if(ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent =
          sf_debug_initialize_chart(_controlMCUSlugsMKIIMachineNumber_,
         49,
         1,
         1,
         4,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_controlMCUSlugsMKIIMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_controlMCUSlugsMKIIMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          _SFD_SET_DATA_PROPS(1,1,1,0,SF_SINGLE,0,NULL,0,0,0,0.0,1.0,0,"u",0,c49_sf_marshall);
          _SFD_SET_DATA_PROPS(0,2,0,1,SF_SINGLE,0,NULL,0,0,0,0.0,1.0,0,"y",0,c49_d_sf_marshall);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"T",0,c49_b_sf_marshall);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"f",0,c49_c_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,455);
        _SFD_CV_INIT_EML_IF(0,0,186,199,-1,411);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
        _SFD_SET_DATA_VALUE_PTR(1UL, c49_u());
        _SFD_SET_DATA_VALUE_PTR(0UL, c49_y());
        _SFD_SET_DATA_VALUE_PTR(2UL, c49_T());
        _SFD_SET_DATA_VALUE_PTR(3UL, c49_f());
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_controlMCUSlugsMKIIMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c49_controlMCUSlugsMKII(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c49_controlMCUSlugsMKII();
  initialize_c49_controlMCUSlugsMKII();
}

static void sf_opaque_enable_c49_controlMCUSlugsMKII(void *chartInstanceVar)
{
  enable_c49_controlMCUSlugsMKII();
}

static void sf_opaque_disable_c49_controlMCUSlugsMKII(void *chartInstanceVar)
{
  disable_c49_controlMCUSlugsMKII();
}

static void sf_opaque_gateway_c49_controlMCUSlugsMKII(void *chartInstanceVar)
{
  sf_c49_controlMCUSlugsMKII();
}

static void sf_opaque_terminate_c49_controlMCUSlugsMKII(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c49_controlMCUSlugsMKII();
}

static void mdlProcessParameters_c49_controlMCUSlugsMKII(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c49_controlMCUSlugsMKII();
}

static void mdlSetWorkWidths_c49_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("controlMCUSlugsMKII",49);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("controlMCUSlugsMKII",49,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"controlMCUSlugsMKII",49,3);
      sf_mark_chart_reusable_outputs(S,"controlMCUSlugsMKII",49,1);
    }
    if (!sf_is_chart_instance_optimized_out("controlMCUSlugsMKII",49)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("controlMCUSlugsMKII",49);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2723885880U));
  ssSetChecksum1(S,(1385951302U));
  ssSetChecksum2(S,(263127059U));
  ssSetChecksum3(S,(1407919819U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c49_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "controlMCUSlugsMKII", 49);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c49_controlMCUSlugsMKII(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c49_controlMCUSlugsMKII;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c49_controlMCUSlugsMKII;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c49_controlMCUSlugsMKII;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c49_controlMCUSlugsMKII;
  chartInstance.chartInfo.disableChart =
    sf_opaque_disable_c49_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c49_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlStart = mdlStart_c49_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c49_controlMCUSlugsMKII;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  chart_debug_initialization(S,1);
}

void c49_controlMCUSlugsMKII_method_dispatcher(SimStruct *S, int_T method, void
 *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c49_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c49_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c49_controlMCUSlugsMKII(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c49_controlMCUSlugsMKII_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

