/* Include files */
#include "controlMCUSlugsMKII_sfun.h"
#include "c10_controlMCUSlugsMKII.h"

/* Type Definitions */

/* Named Constants */
#define c10_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc10_controlMCUSlugsMKIIInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c10_controlMCUSlugsMKII(void);
static void initialize_params_c10_controlMCUSlugsMKII(void);
static void enable_c10_controlMCUSlugsMKII(void);
static void disable_c10_controlMCUSlugsMKII(void);
static void finalize_c10_controlMCUSlugsMKII(void);
static void sf_c10_controlMCUSlugsMKII(void);
static uint8_T *c10_wpStart(void);
static uint8_T *c10_wpCount(void);
static uint8_T *c10_wp0(void);
static real_T *c10_swIncrement(void);
static uint8_T *c10_wp1(void);
static uint8_T *c10_wp2(void);
static uint8_T *c10_wpEnabl(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c10_controlMCUSlugsMKII(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c10_fromWP_not_empty = false;
}

static void initialize_params_c10_controlMCUSlugsMKII(void)
{
}

static void enable_c10_controlMCUSlugsMKII(void)
{
}

static void disable_c10_controlMCUSlugsMKII(void)
{
}

static void finalize_c10_controlMCUSlugsMKII(void)
{
}

static void sf_c10_controlMCUSlugsMKII(void)
{
  uint8_T c10_previousEvent;
  uint32_T c10_u0;
  uint8_T c10_u1;
  uint32_T c10_u2;
  uint8_T c10_u3;
  uint32_T c10_u4;
  uint8_T c10_u5;
  uint32_T c10_u6;
  uint8_T c10_u7;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  c10_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  /*  Declare static variables */
  if(!chartInstance.c10_fromWP_not_empty) {
    /* initialize the static variables */
    chartInstance.c10_fromWP = *c10_wpStart();
    chartInstance.c10_fromWP_not_empty = true;
    c10_u0 = (uint32_T)chartInstance.c10_fromWP + 1UL;
    if(c10_u0 > 255UL) {
      c10_u1 = MAX_uint8_T;
    } else {
      c10_u1 = (uint8_T)c10_u0;
    }
    chartInstance.c10_toWP = c10_u1;
    c10_u2 = (uint32_T)chartInstance.c10_toWP + 1UL;
    if(c10_u2 > 255UL) {
      c10_u3 = MAX_uint8_T;
    } else {
      c10_u3 = (uint8_T)c10_u2;
    }
    if((int16_T)*c10_wpCount() > (int16_T)c10_u3) {
      /*  check if there are more than 2 WPs */
      c10_u4 = (uint32_T)chartInstance.c10_toWP + 1UL;
      if(c10_u4 > 255UL) {
        c10_u5 = MAX_uint8_T;
      } else {
        c10_u5 = (uint8_T)c10_u4;
      }
      chartInstance.c10_totoWP = c10_u5;
    } else {
      chartInstance.c10_totoWP = chartInstance.c10_fromWP;
    }
  }
  if((int16_T)*c10_wpEnabl() == 1) {
    /* if WP Nav was just enabled */
    chartInstance.c10_fromWP = 0U;
    chartInstance.c10_toWP = 1U;
    chartInstance.c10_totoWP = 2U;
  }
  if(*c10_swIncrement() == 1.0) {
    /*  if there is a change of wp */
    chartInstance.c10_fromWP = chartInstance.c10_toWP;
    chartInstance.c10_toWP = chartInstance.c10_totoWP;
    c10_u6 = (uint32_T)chartInstance.c10_totoWP + 1UL;
    if(c10_u6 > 255UL) {
      c10_u7 = MAX_uint8_T;
    } else {
      c10_u7 = (uint8_T)c10_u6;
    }
    chartInstance.c10_totoWP = c10_u7;
    if((int16_T)chartInstance.c10_totoWP > (int16_T)*c10_wpCount()) {
      chartInstance.c10_totoWP = *c10_wpStart();
    }
  }
  *c10_wp0() = chartInstance.c10_fromWP;
  *c10_wp1() = chartInstance.c10_toWP;
  *c10_wp2() = chartInstance.c10_totoWP;
  _sfEvent_ = c10_previousEvent;
}

const mxArray *sf_c10_controlMCUSlugsMKII_get_eml_resolved_functions_info(void)
{
  const mxArray *c10_nameCaptureInfo = NULL;
  c10_nameCaptureInfo = NULL;
  sf_mex_assign(&c10_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c10_nameCaptureInfo;
}

static uint8_T *c10_wpStart(void)
{
  return (uint8_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static uint8_T *c10_wpCount(void)
{
  return (uint8_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static uint8_T *c10_wp0(void)
{
  return (uint8_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static real_T *c10_swIncrement(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
}

static uint8_T *c10_wp1(void)
{
  return (uint8_T *)ssGetOutputPortSignal(chartInstance.S, 2);
}

static uint8_T *c10_wp2(void)
{
  return (uint8_T *)ssGetOutputPortSignal(chartInstance.S, 3);
}

static uint8_T *c10_wpEnabl(void)
{
  return (uint8_T *)ssGetInputPortSignal(chartInstance.S, 3);
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c10_controlMCUSlugsMKII_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3957132591U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1129925150U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3221091369U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2459125982U);
}

mxArray *sf_c10_controlMCUSlugsMKII_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3940192926U);
    pr[1] = (double)(1921161374U);
    pr[2] = (double)(2447562924U);
    pr[3] = (double)(2708645021U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(3));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void sf_opaque_initialize_c10_controlMCUSlugsMKII(void *chartInstanceVar)
{
  initialize_params_c10_controlMCUSlugsMKII();
  initialize_c10_controlMCUSlugsMKII();
}

static void sf_opaque_enable_c10_controlMCUSlugsMKII(void *chartInstanceVar)
{
  enable_c10_controlMCUSlugsMKII();
}

static void sf_opaque_disable_c10_controlMCUSlugsMKII(void *chartInstanceVar)
{
  disable_c10_controlMCUSlugsMKII();
}

static void sf_opaque_gateway_c10_controlMCUSlugsMKII(void *chartInstanceVar)
{
  sf_c10_controlMCUSlugsMKII();
}

static void sf_opaque_terminate_c10_controlMCUSlugsMKII(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c10_controlMCUSlugsMKII();
}

static void mdlProcessParameters_c10_controlMCUSlugsMKII(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c10_controlMCUSlugsMKII();
}

static void mdlSetWorkWidths_c10_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("controlMCUSlugsMKII",10);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("controlMCUSlugsMKII",10,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"controlMCUSlugsMKII",10,4);
      sf_mark_chart_reusable_outputs(S,"controlMCUSlugsMKII",10,3);
    }
    if (!sf_is_chart_instance_optimized_out("controlMCUSlugsMKII",10)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("controlMCUSlugsMKII",10);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3237217820U));
  ssSetChecksum1(S,(959744552U));
  ssSetChecksum2(S,(1362354862U));
  ssSetChecksum3(S,(2004481732U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c10_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "controlMCUSlugsMKII", 10);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c10_controlMCUSlugsMKII(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c10_controlMCUSlugsMKII;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c10_controlMCUSlugsMKII;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c10_controlMCUSlugsMKII;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c10_controlMCUSlugsMKII;
  chartInstance.chartInfo.disableChart =
    sf_opaque_disable_c10_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c10_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlStart = mdlStart_c10_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c10_controlMCUSlugsMKII;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
}

void c10_controlMCUSlugsMKII_method_dispatcher(SimStruct *S, int_T method, void
 *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c10_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c10_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c10_controlMCUSlugsMKII(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c10_controlMCUSlugsMKII_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

