/* Include files */
#include "controlMCUSlugsMKII_sfun.h"
#include "c25_controlMCUSlugsMKII.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "controlMCUSlugsMKII_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c25_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc25_controlMCUSlugsMKIIInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c25_controlMCUSlugsMKII(void);
static void initialize_params_c25_controlMCUSlugsMKII(void);
static void enable_c25_controlMCUSlugsMKII(void);
static void disable_c25_controlMCUSlugsMKII(void);
static void finalize_c25_controlMCUSlugsMKII(void);
static void sf_c25_controlMCUSlugsMKII(void);
static const mxArray *c25_sf_marshall(void *c25_chartInstance, void *c25_u);
static const mxArray *c25_b_sf_marshall(void *c25_chartInstance, void *c25_u);
static const mxArray *c25_c_sf_marshall(void *c25_chartInstance, void *c25_u);
static uint16_T *c25_latest(void);
static uint16_T *c25_history(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c25_controlMCUSlugsMKII(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c25_oldValues_not_empty = false;
  chartInstance.c25_is_active_c25_controlMCUSlugsMKII = 0U;
}

static void initialize_params_c25_controlMCUSlugsMKII(void)
{
}

static void enable_c25_controlMCUSlugsMKII(void)
{
}

static void disable_c25_controlMCUSlugsMKII(void)
{
}

static void finalize_c25_controlMCUSlugsMKII(void)
{
}

static void sf_c25_controlMCUSlugsMKII(void)
{
  int16_T c25_i0;
  uint8_T c25_previousEvent;
  uint16_T c25_b_latest;
  real_T c25_i;
  uint16_T c25_b_history[7];
  int16_T c25_i1;
  int16_T c25_i2;
  real_T c25_b_i;
  int16_T c25_i3;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_DATA_RANGE_CHECK((real_T)*c25_latest(), 1UL);
  for(c25_i0 = 0; c25_i0 < 7; c25_i0 = (int16_T)(c25_i0 + 1)) {
    _SFD_DATA_RANGE_CHECK((real_T)c25_history()[c25_i0], 0UL);
  }
  c25_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,24);
  c25_b_latest = *c25_latest();
  sf_debug_symbol_scope_push(4UL, 0UL);
  sf_debug_symbol_scope_add_verbose("oldValues", 5L, 2UL, 1UL, 7UL, 0UL, 1.0,
   0L, 0.0, 0UL, 0L, 0UL, 1L, 0, &chartInstance.
   c25_oldValues);
  sf_debug_symbol_scope_add("i", &c25_i, c25_c_sf_marshall);
  sf_debug_symbol_scope_add("history", &c25_b_history, c25_b_sf_marshall);
  sf_debug_symbol_scope_add("latest", &c25_b_latest, c25_sf_marshall);
  CV_EML_FCN(0, 0);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,7);
  if(CV_EML_IF(0, 0, !chartInstance.c25_oldValues_not_empty)) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,8);
    for(c25_i1 = 0; c25_i1 < 7; c25_i1 = (int16_T)(c25_i1 + 1)) {
      chartInstance.c25_oldValues[c25_i1] = 0U;
    }
    chartInstance.c25_oldValues_not_empty = true;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,11);
  for(c25_i2 = 0; c25_i2 < 7; c25_i2 = (int16_T)(c25_i2 + 1)) {
    c25_b_history[c25_i2] = 0U;
  }
  c25_i = 7.0;
  c25_b_i = 7.0;
  while(c25_b_i >= 2.0) {
    c25_i = c25_b_i;
    CV_EML_FOR(0, 0, 1);
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,14);
    chartInstance.c25_oldValues[(int16_T)((int16_T)_SFD_EML_ARRAY_BOUNDS_CHECK("oldValues",
      (int32_T)_SFD_INTEGER_CHECK("i", c25_i), 1L
      , 7L, 1L) - 1)] =
      chartInstance.c25_oldValues[(int16_T)((int16_T)_SFD_EML_ARRAY_BOUNDS_CHECK("oldValues",
      (int32_T)
      _SFD_INTEGER_CHECK("", c25_i - 1.0), 1L, 7L, 1L) - 1)];
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,15);
    c25_b_history[(int16_T)((int16_T)_SFD_EML_ARRAY_BOUNDS_CHECK("history",
      (int32_T)_SFD_INTEGER_CHECK("i", c25_i), 1L, 7L, 1L) - 1)]
    =
      chartInstance.c25_oldValues[(int16_T)((int16_T)_SFD_EML_ARRAY_BOUNDS_CHECK("oldValues",
      (int32_T)_SFD_INTEGER_CHECK("", c25_i -
       1.0), 1L, 7L, 1L) - 1)];
    c25_b_i = c25_b_i + -1.0;
    sf_mex_listen_for_ctrl_c(chartInstance.S);
  }
  CV_EML_FOR(0, 0, 0);
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,18);
  chartInstance.c25_oldValues[0] = c25_b_latest;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,19);
  c25_b_history[0] = c25_b_latest;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-19);
  sf_debug_symbol_scope_pop();
  for(c25_i3 = 0; c25_i3 < 7; c25_i3 = (int16_T)(c25_i3 + 1)) {
    c25_history()[c25_i3] = c25_b_history[c25_i3];
  }
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,24);
  _sfEvent_ = c25_previousEvent;
  sf_debug_check_for_state_inconsistency(_controlMCUSlugsMKIIMachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static const mxArray *c25_sf_marshall(void *c25_chartInstance, void *c25_u)
{
  const mxArray *c25_y = NULL;
  uint16_T c25_b_u;
  const mxArray *c25_b_y = NULL;
  c25_y = NULL;
  c25_b_u = *(uint16_T *)c25_u;
  c25_b_y = NULL;
  sf_mex_assign(&c25_b_y, sf_mex_create(&c25_b_u, "y", 5, 0U, 0U, 0));
  sf_mex_assign(&c25_y, c25_b_y);
  return c25_y;
}

static const mxArray *c25_b_sf_marshall(void *c25_chartInstance, void *c25_u)
{
  const mxArray *c25_y = NULL;
  int16_T c25_i4;
  uint16_T c25_b_u[7];
  const mxArray *c25_b_y = NULL;
  c25_y = NULL;
  for(c25_i4 = 0; c25_i4 < 7; c25_i4 = (int16_T)(c25_i4 + 1)) {
    c25_b_u[c25_i4] = (*(uint16_T (*)[7])c25_u)[c25_i4];
  }
  c25_b_y = NULL;
  sf_mex_assign(&c25_b_y, sf_mex_create(&c25_b_u, "y", 5, 0U, 1U, 2, 1, 7));
  sf_mex_assign(&c25_y, c25_b_y);
  return c25_y;
}

static const mxArray *c25_c_sf_marshall(void *c25_chartInstance, void *c25_u)
{
  const mxArray *c25_y = NULL;
  real_T c25_b_u;
  const mxArray *c25_b_y = NULL;
  c25_y = NULL;
  c25_b_u = *(real_T *)c25_u;
  c25_b_y = NULL;
  sf_mex_assign(&c25_b_y, sf_mex_create(&c25_b_u, "y", 0, 0U, 0U, 0));
  sf_mex_assign(&c25_y, c25_b_y);
  return c25_y;
}

const mxArray *sf_c25_controlMCUSlugsMKII_get_eml_resolved_functions_info(void)
{
  const mxArray *c25_nameCaptureInfo = NULL;
  c25_nameCaptureInfo = NULL;
  sf_mex_assign(&c25_nameCaptureInfo, sf_mex_create(NULL, "nameCaptureInfo", 0,
    0U, 1U, 2, 0, 1));
  return c25_nameCaptureInfo;
}

static uint16_T *c25_latest(void)
{
  return (uint16_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static uint16_T *c25_history(void)
{
  return (uint16_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c25_controlMCUSlugsMKII_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1803667671U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(4070156924U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2485448536U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4006215722U);
}

mxArray *sf_c25_controlMCUSlugsMKII_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1082982117U);
    pr[1] = (double)(3275875644U);
    pr[2] = (double)(4062748329U);
    pr[3] = (double)(1690184956U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(5));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(5));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(7);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(5));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(5));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S, unsigned int
 fullDebuggerInitialization)
{
  if(ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent =
          sf_debug_initialize_chart(_controlMCUSlugsMKIIMachineNumber_,
         25,
         1,
         1,
         2,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_controlMCUSlugsMKIIMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_controlMCUSlugsMKIIMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          _SFD_SET_DATA_PROPS(1,1,1,0,SF_UINT16,0,NULL,0,0,0,0.0,1.0,0,"latest",0,c25_sf_marshall);
          {
            unsigned int dimVector[2];
            dimVector[0]= 1;
            dimVector[1]= 7;
            _SFD_SET_DATA_PROPS(0,2,0,1,SF_UINT16,2,&(dimVector[0]),0,0,0,0.0,1.0,0,"history",0,c25_b_sf_marshall);
          }
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,1,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,398);
        _SFD_CV_INIT_EML_IF(0,0,167,188,-1,233);
        _SFD_CV_INIT_EML_FOR(0,0,271,284,352);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
        _SFD_SET_DATA_VALUE_PTR(1UL, c25_latest());
        _SFD_SET_DATA_VALUE_PTR(0UL, c25_history());
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_controlMCUSlugsMKIIMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c25_controlMCUSlugsMKII(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c25_controlMCUSlugsMKII();
  initialize_c25_controlMCUSlugsMKII();
}

static void sf_opaque_enable_c25_controlMCUSlugsMKII(void *chartInstanceVar)
{
  enable_c25_controlMCUSlugsMKII();
}

static void sf_opaque_disable_c25_controlMCUSlugsMKII(void *chartInstanceVar)
{
  disable_c25_controlMCUSlugsMKII();
}

static void sf_opaque_gateway_c25_controlMCUSlugsMKII(void *chartInstanceVar)
{
  sf_c25_controlMCUSlugsMKII();
}

static void sf_opaque_terminate_c25_controlMCUSlugsMKII(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }
  finalize_c25_controlMCUSlugsMKII();
}

static void mdlProcessParameters_c25_controlMCUSlugsMKII(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c25_controlMCUSlugsMKII();
}

static void mdlSetWorkWidths_c25_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("controlMCUSlugsMKII",25);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("controlMCUSlugsMKII",25,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"controlMCUSlugsMKII",25,1);
      sf_mark_chart_reusable_outputs(S,"controlMCUSlugsMKII",25,1);
    }
    if (!sf_is_chart_instance_optimized_out("controlMCUSlugsMKII",25)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("controlMCUSlugsMKII",25);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1276071258U));
  ssSetChecksum1(S,(564170928U));
  ssSetChecksum2(S,(4026398467U));
  ssSetChecksum3(S,(2648176181U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c25_controlMCUSlugsMKII(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "controlMCUSlugsMKII", 25);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c25_controlMCUSlugsMKII(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway =
    sf_opaque_gateway_c25_controlMCUSlugsMKII;
  chartInstance.chartInfo.initializeChart =
    sf_opaque_initialize_c25_controlMCUSlugsMKII;
  chartInstance.chartInfo.terminateChart =
    sf_opaque_terminate_c25_controlMCUSlugsMKII;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c25_controlMCUSlugsMKII;
  chartInstance.chartInfo.disableChart =
    sf_opaque_disable_c25_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c25_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlStart = mdlStart_c25_controlMCUSlugsMKII;
  chartInstance.chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c25_controlMCUSlugsMKII;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */

  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
  chart_debug_initialization(S,1);
}

void c25_controlMCUSlugsMKII_method_dispatcher(SimStruct *S, int_T method, void
 *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c25_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c25_controlMCUSlugsMKII(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c25_controlMCUSlugsMKII(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c25_controlMCUSlugsMKII_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

